package com.sun.net.ssl;

import javax.net.ssl.SSLServerSocketFactory;
import javax.net.ssl.SSLSocketFactory;
import java.security.KeyManagementException;
import java.security.SecureRandom;
import java.security.NoSuchProviderException;
import java.security.NoSuchAlgorithmException;
import java.security.Provider;

@Deprecated
public class SSLContext
{
    private Provider provider;
    private SSLContextSpi contextSpi;
    private String protocol;
    
    protected SSLContext(SSLContextSpi contextSpi, Provider provider, String protocol) {
        this.contextSpi = contextSpi;
        this.provider = provider;
        this.protocol = protocol;
    }
    
    public static SSLContext getInstance(String str) throws NoSuchAlgorithmException {
        try {
            Object[] impl = SSLSecurity.getImpl(str, "SSLContext", (String)null);
            return new SSLContext((SSLContextSpi)impl[0], (Provider)impl[1], str);
        }
        catch (NoSuchProviderException ex) {
            throw new NoSuchAlgorithmException(str + " not found");
        }
    }
    
    public static SSLContext getInstance(String s, String s2) throws NoSuchAlgorithmException, NoSuchProviderException {
        if (s2 == null || s2.length() == 0) {
            throw new IllegalArgumentException("missing provider");
        }
        Object[] impl = SSLSecurity.getImpl(s, "SSLContext", s2);
        return new SSLContext((SSLContextSpi)impl[0], (Provider)impl[1], s);
    }
    
    public static SSLContext getInstance(String s, Provider provider) throws NoSuchAlgorithmException {
        if (provider == null) {
            throw new IllegalArgumentException("missing provider");
        }
        Object[] impl = SSLSecurity.getImpl(s, "SSLContext", provider);
        return new SSLContext((SSLContextSpi)impl[0], (Provider)impl[1], s);
    }
    
    public final String getProtocol() {
        return this.protocol;
    }
    
    public final Provider getProvider() {
        return this.provider;
    }
    
    public final void init(KeyManager[] array, TrustManager[] array2, SecureRandom secureRandom) throws KeyManagementException {
        this.contextSpi.engineInit(array, array2, secureRandom);
    }
    
    public final SSLSocketFactory getSocketFactory() {
        return this.contextSpi.engineGetSocketFactory();
    }
    
    public final SSLServerSocketFactory getServerSocketFactory() {
        return this.contextSpi.engineGetServerSocketFactory();
    }
}
